<?
/*  $id: $
This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been write by Julien Dumont - copyright (C) 2001
Ce script  t crit par Julien Dumont - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/


function get_intranet_infos()  // return 2 params : [0] network , [1] netmask.
{
        $eth1 = fopen("/etc/sysconfig/network-scripts/ifcfg-eth1", "r");
         while (!feof($eth1))
         {
                $buffer=fread($eth1,4096);
                $contenu = split("\n",$buffer,"10"); // no more ten elements in the array
                while($line = array_shift($contenu))
                {
                        if(ereg("NETWORK",$line))
                        {
                                list ($flag,$network) = split("=",$line,2);
                                $network = ereg_replace("\"","",$network);
                                $network = ereg_replace("\'","",$network);
                                $network = ereg_replace("\n","",$network);
                        }
                        elseif(ereg("NETMASK",$line))
                        {
                                list ($flag,$netmask) = split("=",$line,2);
                                $netmask = ereg_replace("\"","",$netmask);
                                $netmask = ereg_replace("\'","",$netmask);
                                $netmask = ereg_replace("\n","",$netmask);
                        }
                }
         }
         fclose($eth1);
         $val[0] = $network;
         $val[1] = $netmask;
         return($val);
}

function is_ip_subnet($ip,$net,$mask) // return 1 if ip is in net & mask params or 0 if it isn't
{
        list ($intranet1,$intranet2,$intranet3,$intranet4) = split("\.",$net,4);
        list ($intramask1,$intramask2,$intramask3,$intramask4) = split("\.",$mask,4);
        list ($ip1,$ip2,$ip3,$ip4) = split("\.",$ip,4);
        if((decbin($ip1) & decbin($intramask1)) == decbin($intranet1))
        {
                $check1 = 1;
        }
        if((decbin($ip2) & decbin($intramask2)) == decbin($intranet2))
        {
                $check2 = 1;
        }
        if((decbin($ip3) & decbin($intramask3)) == decbin($intranet3))
        {
                $check3 = 1;
        }
        if((decbin($ip4) & decbin($intramask4)) == decbin($intranet4))
        {
                $check4 = 1;
        }
        if( ($check1 == $check2) && ($check1 == $check3) && ($check1== $check4) && ($check1 == 1) )
        {
                $val = 1;
        }
        else
        {
                $val = 0;
        }
        return($val);
}

function get_subnet_infos($db,$subnetid) // return subnet infosrmations  id [0] nom [1] network [2] netmask [3] status [4] subnetinfos formated ( net /netmask ) [6]
{
        require("../../slis.conf.php");
        require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
        $query = "select * from subnets where id='$subnetid' ;";
        $result = pg_exec($db,$query);
        $numrow = pg_numrows($result); // number of subnets
        if($numrow == 1) // god option
        {
                $row = pg_fetch_row($result,0);
                $row[6] = $row[2]." / ".$row[3];
        }
        else
        {
                $error = errormsg("$lang_badparams_submit : in subnet include function  get_subnet_infos");
                print "<p>$error<center>";
        }
        return($row);
}

function get_number_subnet($net,$mask)  // return the max number of subnet to create [0] and  each subnet possible [1] (network:netmask::network2:netmask2)
{
        list ($intranet1,$intranet2,$intranet3,$intranet4) = split("\.",$net,4);
        list ($intramask1,$intramask2,$intramask3,$intramask4) = split("\.",$mask,4);
        if($mask == "255.255.255.0") // class C  8 subnet de 32 address
        {
                $val[0] = 8; // nb of subnet
                $subnetmask="255.255.255.224";
                $nb_subnet = 8;
                if($intranet4 == 0)
                {
                        $tmpnet = "$intranet1.$intranet2.$intranet3.$intranet4".":$subnetmask";
                        $tmpnet .= "::"."$intranet1.$intranet2.$intranet3.".($intranet4+32).":$subnetmask";
                        $tmpnet .= "::"."$intranet1.$intranet2.$intranet3.".($intranet4+64).":$subnetmask";
                        $tmpnet .= "::"."$intranet1.$intranet2.$intranet3.".($intranet4+96).":$subnetmask";
                        $tmpnet .= "::"."$intranet1.$intranet2.$intranet3.".($intranet4+128).":$subnetmask";
                        $tmpnet .= "::"."$intranet1.$intranet2.$intranet3.".($intranet4+160).":$subnetmask";
                        $tmpnet .= "::"."$intranet1.$intranet2.$intranet3.".($intranet4+192).":$subnetmask";
                        $tmpnet .= "::"."$intranet1.$intranet2.$intranet3.".($intranet4+224).":$subnetmask";
                        $val[1] = $tmpnet;
                        unset ($tmpnet);
                }
                else  // bad intranet network format
                {
                        $val[0] = 0;
                }
        }
        elseif($mask == "255.255.0.0")  //class B  30 subnet by default
        {
                $val[0] = 256;
                $subnetmask="255.255.255.0";
                $nb_subnet = 32; // 32 is default. we can up to 256 subnet
                $count = 1;
                $final = 100;
                while($count != ($nb_subnet+1))
                {
                        if($count == 1)
                        {
                               $tmpnet = "$intranet1.$intranet2.$final.0".":$subnetmask";
                        }
                        else
                        {
                                $tmpnet .= "::"."$intranet1.$intranet2.$final.0".":$subnetmask";
                        }
                        $final = $final+1;
                        $count++;
                }
                $val[1] = $tmpnet;
                unset($tmpnet);
        }
        else  // not yet implemented
        {
                $val[0] = 0;
        }
        return($val);
}

function change_subnet_status($db,$subnetid,$status) // return "ok" or "error msg". $status is mode : actif or inactif
{
        require("../../slis.conf.php");
        require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
         if( ($status == "actif")  && ($subnetid) )
        {
                $query = "update subnets set status='1' where id='$subnetid' ;";
                $result = pg_exec($db,$query);
                if($result) { $val = "ok"; }
        }
        elseif( ($status == "inactif") && ($subnetid) )
        {
                $query = "update subnets set status='0' where id='$subnetid' ;";
                $result = pg_exec($db,$query);
                if($result) { $val = "ok"; }
        }
        else
        {
                $val = errormsg("$lang_badparams_submit in subnet fonction change_subnet_status");
        }
        return($val);
}

function get_subnet_status($db,$subnetid) // return 0 if subnet is inactif or 1 if it is in [0] and htmlcode for picture in [1]
{
        require("../../slis.conf.php");
        require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
        $subinfo =  get_subnet_infos($db,$subnetid);;
        if($subinfo[4] == "t")  // actif
        {
                $val[0] = 1;
                $val[1] = "<a href=\"subnets.php?status=status&mode=inactif&id=$subnetid\"><img src=\"../images/ledgreen.gif\" BORDER=\"0\" width=\"20\" hight=\"20\" ALIGN=\"absmiddle\" alt=\"$lang_Subnet_inactive\">";
        }
        else  // inactif
        {
                $val[0] = 0;
                $val[1] = "<a href=\"subnets.php?status=status&mode=actif&id=$subnetid\"><img src=\"../images/ledred.gif\" BORDER=\"0\" width=\"20\" hight=\"20\" ALIGN=\"absmiddle\" alt=\"$lang_Subnet_active\"></a>";
        }
        return($val);
}

function get_subnet_name($db,$subnetid)  // return subnet Name or error if don't existe
{
        $query = "SELECT nom from subnets where id='$subnetid' ;";
        $result = pg_exec($db,$query);
        $num = pg_numrows($result); // number of rows
        if($num == 1)
        {
                $valtmp =  pg_fetch_row($result,0);
                $val = $valtmp[0];
                unset ($valtmp);
        }
        else
        {
                $val = "error";
        }
        return($val);
}

function init_subnets($db,$net,$mask)  // adding all possible subnet for intranet in database, return "ok" or "error msg"
{
        $values = get_number_subnet($net,$mask);
        $allsubnets = split("::",$values[1],256);
        $number = 1;
        while($line = array_shift($allsubnets))
        {
                list($net, $mask) = split(":",$line,2);
                $query = "insert into subnets (nom,network,netmask,status) values('$number','$net','$mask','No'); ";
                $result = pg_exec($db,$query);
                $number++;
        }
}

function show_subnets($db)   // return all subnet declare on the system. html code [0] , number of subnet  [1] and number of subner that are active [2]
{
        require("../../slis.conf.php");
        require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
        // all subnet [1]
        $query = "SELECT * from subnets order by id ;";
        $result = pg_exec($db,$query);
        $total_subnet = pg_numrows($result); // number of subnets
        // html code
        $code = "<center><i>$lang_SUBNET</i></center><br>\n";
        $code .= "<center>\n<table align=\"center\" border=\"0\">\n<tr>\n";
        $code .= "<td align=center><font color=\"#555555\">$lang_Status</font></td>\n";
        $code .= "<td align=center><font color=\"#555555\">$lang_Name</font></td><td align=center><font color=\"#555555\">$lang_Infos</font></td>";
        $code .= "<td align=center><font color=\"#555555\">$lang_Subnet_Hours</font></td>\n";
        while($row_number != $total_subnet) // all subnets data
        {
                $row = pg_fetch_row($result,$row_number);
                $id = $row[0];
                $nom = $row[1];
                $network = $row[2];
                $netmask = $row[3];
                $status = $row[4];
                // html code
                $tmp = get_subnet_status($db,$id);
                $htmlstatus = $tmp[1];
                unset($tmp);
                $code .= "<tr>\n";
                $code .= "<td align=center>$htmlstatus</td>\n";
                $code .= "<td><b>$nom</b> <a href=\"subnet-change.php?mode=nom&id=$id\"><img src=\"../images/pen.gif\" BORDER=\"0\" width=\"20\" hight=\"20\" ALIGN=\"absmiddle\" alt=\"$lang_Rename\"></a> <img src=\"../images/trash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Delete\"></td>";
                $code .= "<td><font size=\"2\" color=\"#0044CF\"><i>( $network / $netmask )</i></font></td>";
                $code .= "<td align=center><a href=\"schedule.php?subnetid=$id\"><img src=\"../images/clock.gif\" BORDER=\"0\" width=\"20\" hight=\"20\" ALIGN=\"absmiddle\" alt=\"$lang_Subnet_Hours\"></a></td>\n";
                $row_number++;
        }
        $code .= "\n</table>\n</center>\n";
        // actif subnet [2]
        $query2 = "select subnets.id from subnets,subnetstat where subnets.id=subnetstat.subid ;";
        $result2 = pg_exec($db,$query2);
        $actif_subnet = pg_numrows($result2);
        // return val(s)
        $val[0] = $code;
        $val[1] = $total_subnet;
        $val[2] = $actif_subnet;
        return($val);
}

function get_subnet_bar_del($barid,$actif,$inactif,$subnetid) // return html picture of trash for insert in status bar to delete plage.
{
        require("../../slis.conf.php");
        require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
        if($barid != 0)
        {
                $alt1 = get_hours($actif);
                $alt2 = get_hours($inactif);
                $alt = "$lang_Delete de $alt1 &agrave; $alt2";
                $val = "<a href=schedule.php?mode=remove&subnetid=$subnetid&id=$barid><img src=\"../images/trash.gif\" border=\"0\" alt=\"$alt\"></a>";
        }
        else
        {
                $val  = "<img src=\"../images/trans.gif\" border=\"0\">";
        }
        return(center("$val"));
}

function draw_subnet_hours($db,$day,$subnetid)  // return an html status bar by day for subnet in params activity hours.
{
        require("../inc/themes.inc.php"); // output themes.
        $val = "<TABLE CELLPADDING=\"1\" CELLSPACING=\"1\" BORDER=\"0\" WIDTH=\"100%\"><tr>\n";
        $day_number = day_number($day);
        $coef = "2.5"; // coeficient diviseur
        $bar_size = 1440 / $coef; // 576
        $red = "#FF0010"; // inactif
        $green = "#10FF00"; // actif
        $query = "SELECT * from subnetstat where subid='$subnetid' and days='$day_number' order by actif;";
        $result = pg_exec($db,$query);
        $total = pg_numrows($result); // number of plage
        if($total == 0)
        {
                $val .= "<td width=\"$bar_size\" bgcolor=\"$red\" colspan=\"4\">".get_subnet_bar_del(0,0,0,0)."</td>\n";
        }
        else // draw all plage
        {
                while($row_number != $total)
                {
                        $row = pg_fetch_row($result,$row_number);
                        $id = $row[0];
                        $subid = $row[1];
                        $actif = $row[2];
                        $inactif = $row[3];
                        $days = $row[4];
                        $bar_size = array();
                        $realactif = $actif / $coef;
                        if((!($row_number)) && ($actif != 0)) // first instance of while
                        {
                                $oinactif =  $realactif;
                                $size = $realactif - 2;
                                $val .= "<td width=\"$size\" bgcolor=\"$red\">".get_subnet_bar_del(0,0,0,0)."</td>";
                                $tdnb++;
                        }

                        if($realactif > $oinactif) // inactif part of bar
                        {
                                $size = ($realactif - $oinactif) - 2 ;
                                $val .= "<td width=\"$size\" bgcolor=\"$red\">".get_subnet_bar_del(0,0,0,0)."</td>";
                                $tdnb++;
                        }
                        $size_tmp = $inactif - $actif; // in seconde
                        $size_tmp = ($size_tmp / $coef);
                        $size = $size_tmp - 2;
                        $val .= "<td width=\"$size\" bgcolor=\"$green\">".get_subnet_bar_del($id,$actif,$inactif,$subid)."</td>";
                        $tdnb++;
                        $oinactif = $inactif / $coef;
                        $row_number++;
                }
                if($inactif < 1430)
                {
                        $size_tmp = 1440 - $inactif;
                        $size = ($size_tmp / $coef) - 2;
                        $val .=  "<td width=\"$size\" bgcolor=\"$red\">".get_subnet_bar_del(0,0,0,0)."</td>";
                }
        }
        unset($size_tmp);
        $val .= "</TABLE>\n";
        $html = "<TABLE BGCOLOR=\"#000000\" CELLPADDING=\"0\" CELLSPACING=\"0\" BORDER=\"0\"><TR><TD>$val\n</TABLE>";
        return($html);
}

function check_subnet_params($db,$start,$end,$subid,$day) // return 1 if ok or error msg
{
        require("../../slis.conf.php");
        require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
        $check = 0; // make default condition to false
        if($start < $end)
        {
                $query = "SELECT actif,inactif from subnetstat where subid='$subid' and days='$day' order by actif;";
                $result = pg_exec($db,$query);
                $total = pg_numrows($result); // number of plage
                if($total == 0)
                {
                        $val = 1;
                        return($val);
                        exit;
                }
                else
                {
                        while($row_number != $total)
                        {
                                $row = pg_fetch_row($result,$row_number);
                                $actif = $row[0];
                                $inactif = $row[1];
                                if( ($start <= $inactif) && ($start >= $actif) )
                                {
                                        $val = "$lang_subnet_error2";
                                        return($val);
                                        exit;
                                }
                                elseif( ($end <= $inactif) && ($end >= $actif) )
                                {
                                        $val = "$lang_subnet_error2";
                                        return($val);
                                        exit;
                                }
                                elseif( ($inactif <= $end) && ($inactif >= $start) )
                                {
                                        $val = "$lang_subnet_error2";
                                        return($val);
                                        exit;
                                }
                                elseif( ($actif <= $end) && ($actif >= $start) )
                                {
                                        $val = "$lang_subnet_error2";
                                        return($val);
                                        exit;
                                }
                                else
                                {
                                        $row_number++;
                                }
                        }
                        $val = 1;
                        return($val) ;
                        exit;
                }
        }
        else
        {
                $val = "$lang_subnet_error1";
                return($val);
        }
}

function get_hours($time) // return time in hours and minutes
{
       $div = $time / 60;
       $hour = intval($div);
       $tmp = $hour * 60;
       $minutes = $time - $tmp;
       if($minutes < 10)
       {
                $minutes = "0".$minutes;
       }
       return("$hour H $minutes");
}

function day_number($day)  // return one unique digit for each day
{
        $day = strtolower($day);
        if($day == "lundi")
        {
                $val = 1;
        }
        elseif($day == "mardi")
        {
                $val = 2;
        }
        elseif($day == "mercredi")
        {
                $val = 3;
        }
        elseif($day == "jeudi")
        {
                $val = 4;
        }
        elseif($day == "vendredi")
        {
                $val = 5;
        }
        elseif($day = "samedi")
        {
                $val = 6;
        }
        elseif($day = "dimanche")
        {
                $val = 7;
        }
        elseif($day = "today")
        {
                $val = 0;
        }
        else
        {
                die("Error in subnet.inc.php : Bad params days in day_number function.");
        }
        return($val);
}
?>
