<?PHP
/* $Id: ip_filters.php,v 1.17 2001/06/18 09:11:07 bzizou Exp $

IP FILTERS INTERFACE
This script interacts with the SQL table "security_filters" and then, with the
system script "mkfilters".

This script is part of the SLIS Project initiated by the CARMI-Internet
(Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet
(Acadmie de Grenoble - France 38).

This script have been writen by Bruno Bzeznik - copyright (C) 2001
Ce script  t crit par Bruno Bzeznik - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire.
Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License
along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail
to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  <slis@ac-grenoble.fr>
*/

// loading libs and init
require("../inc/html.inc.php");
require("../inc/lib.inc.php");
require("../inc/pgsql.inc.php");

if ($action != "firewall_assistant") {
  print startHTML("IP FILTERING");
}

###############################################################################################################################################
// The index page
if ($action=="index" || $action =="") {

  // Prepare the message
  $text = "<BR><FONT FACE=Helvetica,Arial>\n";
  $text .= "<UL><B>\n";
  $text .= menu_item("ip_filters.php?action=forward_form",$lang_ipfilters_forward,0,0);
  $text .= menu_item("ip_filters.php?action=firewall_form",$lang_ipfilters_firewall,0,0) ."<P>";
  $text .= menu_item("ip_filters.php?action=print","<I>$lang_Expert_only</I>: $lang_ipfilters_Print",0,0);
  $text .= "</B></UL><BR><P>";

  // print the message
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_adv_IP_filters,$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";        
}


###############################################################################################################################################
// The form for forwarding rules
if ($action=="forward_form") {

  $db = dbconnect();

  // Variables searching
  $query="select predefined_string from security_filters where predefined='true' and type='forward'"; 
  $result=pg_exec($db,$query);
  $level=pg_result($result,0,"predefined_string");
  $s1="";$s2="";$s3="";$s4="";$s5="";
  switch ($level) {
    case "all" : $s1="SELECTED"; break;
    case "level1" : $s2="SELECTED"; break;
    case "level2" : $s3="SELECTED"; break;
    case "level3" : $s4="SELECTED"; break;
    case "nothing" : $s5="SELECTED"; break;
  }
  $query="select * from security_filters where predefined='false' and type='forward' order by filter"; 
  $result=pg_exec($db,$query);
  for ($i=0;$i<pg_numrows($result);$i++) {
     $j=$i+1;
     $var="rule$j";
     $$var=pg_result($result,$i,"rule");
     $var="source$j";
     $$var=pg_result($result,$i,"src");
     $var="source_mask$j";
     $$var=pg_result($result,$i,"src_mask");
     $var="source_port$j";
     $$var=pg_result($result,$i,"src_port");
     $var="dest$j";
     $$var=pg_result($result,$i,"dst");
     $var="dest_mask$j";
     $$var=pg_result($result,$i,"dst_mask");
     $var="dest_port$j";
     $$var=pg_result($result,$i,"dst_port");
     $var="protocol$j";
     $$var=pg_result($result,$i,"protocol");
  }

  if ($n == "") { $n=pg_numrows($result); };
  $nplus=$n+1;
  $nminus=$n-1;


  // Intro
  $text = "<FORM action=\"ip_filters.php\" METHOD=get>\n<BR><FONT FACE=Helvetica,Arial>\n";
  $text .= "<INPUT TYPE=hidden NAME=action VALUE=forward>\n";
  $text .= "<I>$lang_ipfilters_Forward_intro<BR>\n";
  $text .= "<A HREF=ip_filters.php?action=forward_hlp1>$lang_ipfilters_Forward_intro_link</A></I>\n";
  $text .= "<HR><P>\n<UL>\n<LI>$lang_ipfilters_Forward_levels: \n";
  $text .= "<SELECT NAME=level>\n";
  $text .= "<OPTION VALUE=all $s1>$lang_ipfilters_Forward_level $lang_ipfilters_Forward_level_all\n";
  $text .= "<OPTION VALUE=level1 $s2>$lang_ipfilters_Forward_level 1\n";
  $text .= "<OPTION VALUE=level2 $s3>$lang_ipfilters_Forward_level 2\n";
  $text .= "<OPTION VALUE=level3 $s4>$lang_ipfilters_Forward_level 3\n";
  $text .= "<OPTION VALUE=nothing $s5>$lang_ipfilters_Forward_level $lang_ipfilters_Forward_level_nothing\n";
  $text .= "</SELECT><P>\n";

  $text .= "<LI>$lang_ipfilters_Forward_manu:<BR>\n";
  $text .= "</UL>\n";
  $text .= "<P><I>&nbsp;&nbsp;&nbsp;<A HREF=ip_filters.php?action=forward_form&n=$nplus>$lang_Add 1 $lang_Line</A></I><P>\n";

  if ("$n" != "" && $n > 0) {
    $text .= "<TABLE BORDER=0>\n";
    $text .= "<TR><TD><FONT SIZE=-1><B>N</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Rule</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Protocol</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Source</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Source mask</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Port</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Dest</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Dest mask</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Port</B></FONT></TD></TR>\n";
    for ($i=1;$i<=$n;$i++) {
      $text .= "<TR>\n";
      $text .= "<TD><FONT SIZE=-1><B>$i</B></FONT></TD>\n";
      $var="rule$i"; $var=$$var;
      $s1="";$s2="";$s3="";
      switch ($var) {
        case "MASQ" : $s1="SELECTED"; break;
        case "ACCEPT" : $s3="SELECTED"; break;
        case "DENY" : $s2="SELECTED"; break;
        case "REJECT" : $s2="SELECTED"; break;
      }      
      $text .= "<TD><FONT SIZE=-1><SELECT NAME=rule$i>\n";
      $text .= "<OPTION VALUE=MASQ $s1>MASQ\n";
      $text .= "<OPTION VALUE=DENY $s2>DENY\n";
      $text .= "<OPTION VALUE=ACCEPT $s3>ACCEPT\n";
      $text .= "</SELECT></FONT></TD>\n";
      $var="protocol$i"; $var=$$var;
      $s1="";$s2="";$s3="";
      switch ($var) {
        case "tcp" : $s1="SELECTED"; break;
        case "udp" : $s2="SELECTED"; break;
        case "icmp" : $s3="SELECTED"; break;
      }      
      $text .= "<TD><FONT SIZE=-1><SELECT NAME=protocol$i>\n";
      $text .= "<OPTION VALUE=\"\">ALL\n";
      $text .= "<OPTION VALUE=tcp $s1>TCP\n";
      $text .= "<OPTION VALUE=udp $s2>UDP\n";
      $text .= "<OPTION VALUE=icmp $s3>ICMP\n";
      $text .= "</SELECT></FONT></TD>\n";
      $var="source$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=source$i VALUE=\"$var\" SIZE=15 MAXLENGTH=15></FONT></TD>\n";
      $var="source_mask$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=source_mask$i VALUE=\"$var\" SIZE=15 MAXLENGTH=15></FONT></TD>\n";
      $var="source_port$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=source_port$i VALUE=\"$var\" SIZE=5 MAXLENGTH=5></FONT></TD>\n";
      $var="dest$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=dest$i VALUE=\"$var\" SIZE=15 MAXLENGTH=15></FONT></TD>\n";
      $var="dest_mask$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=dest_mask$i VALUE=\"$var\" SIZE=15 MAXLENGTH=15></FONT></TD>\n";
      $var="dest_port$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=dest_port$i VALUE=\"$var\" SIZE=5 MAXLENGTH=5></FONT></TD>\n";
      $text .= "</TR>";
    }
    $text .= "</TABLE>\n";
    $text .= "<P><I>&nbsp;&nbsp;&nbsp;<A HREF=ip_filters.php?action=forward_form&n=$nminus>$lang_Del 1 $lang_Line</A></I><P>\n";
    $text .= "<P><I>$lang_ipfilters_Forward_manu_info</I>\n";
  }

  if ($n == "") { $n=0; };
  $text .= "<INPUT TYPE=HIDDEN NAME=\"n\" VALUE=\"$n\">\n";
  $text .= "\n<P><UL>\n<LI>$lang_Validation: <INPUT TYPE=submit VALUE=\" OK \"></UL></FORM><HR>\n";
  $text .= "<DIV ALIGN=RIGHT><A HREF=ip_filters.php>&lt;&lt;</A>&nbsp;&nbsp;</DIV><BR>\n";

  // Print the form
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_ipfilters_Forward_title,$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";        
}



###############################################################################################################################################
# Validation of the forward form
if ($action=="forward") {

  # Validity tests
  $ok=1;
  $text = "<BR><FONT FACE=HELVETICA,ARIAL>\n";
  if ($level != "all" && $level != "nothing" && $level != "level1" && $level != "level2" && $level != "level3") {$ok=0; $text .= "<FONT COLOR=FF0000>$level is not a valid rule set!</FONT><BR>\n";}  
  for ($i=1;$i<=$n;$i++) {
    $var="rule$i"; $rule=$$var;
    $var="protocol$i"; $protocol=$$var;
    $var="source$i"; $source=$$var;
    $var="source_mask$i"; $source_mask=$$var;
    $var="source_port$i"; $source_port=$$var;
    $var="dest$i"; $dest=$$var;
    $var="dest_mask$i"; $dest_mask=$$var;
    $var="dest_port$i"; $dest_port=$$var;
    if ($source_port == "") { $source_port=0; }
    if ($dest_port == "") { $dest_port=0; }
    if ($rule != "MASQ" && $rule != "DENY" && $rule != "ACCEPT") {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $rule is not a valid policy</FONT><BR>\n";}
    if (!isip($source)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error1 ($source)</FONT><BR>\n";}
    if (!isip($source_mask)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error2 ($source_mask)</FONT><BR>\n";}
    if (!(preg_match("/^\d*$/",$source_port)) || !($source_port>=0 && $source_port<=65535)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error3 ($source_port)</FONT><BR>\n";}
    if (!isip($dest)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error4 ($dest)</FONT><BR>\n";}
    if (!isip($dest_mask)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error5 ($dest_mask)</FONT><BR>\n";}
    if (!(preg_match("/^\d*$/",$dest_port)) || !($dest_port>=0 && $dest_port<=65535)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error6 ($dest_port)</FONT><BR>\n";}
  }

  # Do the inserts only if tests have been passed
  if ($ok==1) {

    $error="";

    # Clear the old rules
    $db = dbconnect();
    $query="delete from security_filters where type='forward'"; 
    $result=pg_exec($db,$query);

    # Insert the predefined rule
    $query="insert into security_filters (filter,type,rule,predefined,predefined_string) values ('1000','forward','ACCEPT','true','$level')"; 
    $result=pg_exec($db,$query);

    # Insert the manualy added rules
    for ($i=1;$i<=$n;$i++) {
      $filter=1000+$i;
      $var="rule$i"; $rule=$$var;
      $var="protocol$i"; $protocol=$$var;
      $var="source$i"; $source=$$var;
      $var="source_mask$i"; $source_mask=$$var;
      $var="source_port$i"; $source_port=$$var;
      $var="dest$i"; $dest=$$var;
      $var="dest_mask$i"; $dest_mask=$$var;
      $var="dest_port$i"; $dest_port=$$var;
      if ($source_port == "") { $source_port=0; }
      if ($dest_port == "") { $dest_port=0; }
      $query="insert into security_filters (filter,type,rule,predefined,protocol,src,src_mask,src_port,dst,dst_mask,dst_port) values ('$filter','forward','$rule','false','$protocol','$source','$source_mask','$source_port','$dest','$dest_mask','$dest_port')"; 
      $result=pg_exec($db,$query);
    }
    $text .= "<I>". $lang_ipfilters_OK ."</I><BR>\n";
    touch("$QUEUE/tbp");
  }
  else { $error="<FONT COLOR=FF0000>ERROR</FONT>"; }
  $text .= "<BR><DIV ALIGN=RIGHT><A HREF=ip_filters.php?action=forward_form>&lt;&lt;</A>&nbsp;&nbsp;</DIV></FONT><BR>\n";
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,"Filters script $error",$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";  
}


###############################################################################################################################################
// The form for firewalling rules
if ($action=="firewall_form") {

  $db = dbconnect();

  // Variables searching
  $query="select predefined_string from security_filters where predefined='true' and type='input'"; 
  $result=pg_exec($db,$query);
  $level=pg_result($result,0,"predefined_string");
  $s1="";$s2="";$s3="";$s4="";$s5="";
  switch ($level) {
    case "all" : $s1="SELECTED"; break;
    case "level1" : $s2="SELECTED"; break;
    case "level2" : $s3="SELECTED"; break;
    case "level3" : $s4="SELECTED"; break;
    case "nothing" : $s5="SELECTED"; break;
  }
  $query="select * from security_filters where predefined='false' and type='input' order by filter"; 
  $result=pg_exec($db,$query);
  for ($i=0;$i<pg_numrows($result);$i++) {
     $j=$i+1;
     $var="rule$j";
     $$var=pg_result($result,$i,"rule");
     $var="source$j";
     $$var=pg_result($result,$i,"src");
     $var="source_mask$j";
     $$var=pg_result($result,$i,"src_mask");
     $var="source_port$j";
     $$var=pg_result($result,$i,"src_port");
     $var="dest$j";
     $$var=pg_result($result,$i,"dst");
     $var="dest_mask$j";
     $$var=pg_result($result,$i,"dst_mask");
     $var="dest_port$j";
     $$var=pg_result($result,$i,"dst_port");
     $var="protocol$j";
     $$var=pg_result($result,$i,"protocol");
  }

  if ($n == "") { $n=pg_numrows($result); };
  $nplus=$n+1;
  $nminus=$n-1;


  // Intro
  $text = "<FORM action=\"ip_filters.php\" METHOD=get>\n<BR><FONT FACE=Helvetica,Arial>\n";
  $text .= "<INPUT TYPE=hidden NAME=action VALUE=firewall>\n";
  $text .= "<I>$lang_ipfilters_Firewall_intro<BR>\n";
  $text .= "<A HREF=ip_filters.php?action=firewall_hlp1>$lang_ipfilters_Firewall_intro_link</A></I>\n";
  $text .= "<HR><P>\n<UL>\n<LI>$lang_ipfilters_Forward_levels: \n";
  $text .= "<SELECT NAME=level>\n";
  $text .= "<OPTION VALUE=all $s1>$lang_ipfilters_Firewall_level_all\n";
  $text .= "<OPTION VALUE=level2 $s3>$lang_ipfilters_Firewall_level_optimum\n";
  $text .= "<OPTION VALUE=nothing $s5>$lang_ipfilters_Firewall_level_nothing\n";
  $text .= "</SELECT><P>\n";

  $text .= "<LI>$lang_ipfilters_Forward_manu:<BR>\n";
    $text .= "<P><I>&nbsp;&nbsp;&nbsp;<A HREF=ip_filters.php?action=firewall_form&pn=$pn&n=$nplus>$lang_Add 1 $lang_Virgin_line</A></I><BR>\n";
  $text .= "</UL>\n";  

  if ("$n" != "" && $n > 0) {
    $text .= "<TABLE BORDER=0>\n";
    $text .= "<TR><TD><FONT SIZE=-1><B>N</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Rule</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Protocol</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Source</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Source mask</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Port</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Dest</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Dest mask</B></FONT></TD>\n";
    $text .= "<TD ALIGN=CENTER><FONT SIZE=-1><B>Port</B></FONT></TD></TR>\n";
    for ($i=1;$i<=$n;$i++) {
      $text .= "<TR><TD><FONT SIZE=-1><B>$i</B></FONT></TD>\n";
      $var="rule$i"; $var=$$var;
      $s1="";$s2="";$s3="";
      switch ($var) {
        case "DENY" : $s1="SELECTED"; break;
        case "ACCEPT" : $s2="SELECTED"; break;
      }      
      $text .= "<TD><FONT SIZE=-1><SELECT NAME=rule$i>\n";
      $text .= "<OPTION VALUE=DENY $s1>DENY\n";
      $text .= "<OPTION VALUE=ACCEPT $s2>ACCEPT\n";
      $text .= "</SELECT></FONT></TD>\n";
      $var="protocol$i"; $var=$$var;
      $s1="";$s2="";$s3="";
      switch ($var) {
        case "tcp" : $s1="SELECTED"; break;
        case "udp" : $s2="SELECTED"; break;
        case "icmp" : $s3="SELECTED"; break;
      }      
      $text .= "<TD><FONT SIZE=-1><SELECT NAME=protocol$i>\n";
      $text .= "<OPTION VALUE=\"\">ALL\n";
      $text .= "<OPTION VALUE=tcp $s1>TCP\n";
      $text .= "<OPTION VALUE=udp $s2>UDP\n";
      $text .= "<OPTION VALUE=icmp $s3>ICMP\n";
      $text .= "</SELECT></FONT></TD>\n";
      $var="source$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=source$i VALUE=\"$var\" SIZE=15 MAXLENGTH=15></FONT></TD>\n";
      $var="source_mask$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=source_mask$i VALUE=\"$var\" SIZE=15 MAXLENGTH=15></FONT></TD>\n";
      $var="source_port$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=source_port$i VALUE=\"$var\" SIZE=5 MAXLENGTH=5></FONT></TD>\n";
      $var="dest$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=dest$i VALUE=\"$var\" SIZE=15 MAXLENGTH=15></FONT></TD>\n";
      $var="dest_mask$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=dest_mask$i VALUE=\"$var\" SIZE=15 MAXLENGTH=15></FONT></TD>\n";
      $var="dest_port$i"; $var=$$var;
      $text .= "<TD><FONT SIZE=-1><INPUT TYPE=TEXT NAME=dest_port$i VALUE=\"$var\" SIZE=5 MAXLENGTH=5></FONT></TD>\n";
      $text .= "</TR>";
    }
    $text .= "</TABLE>\n";
    $text .= "<P><I>&nbsp;&nbsp;&nbsp;<A HREF=ip_filters.php?action=firewall_form&pn=$pn&n=$nminus>$lang_Del 1 $lang_Line</A></I><P>\n";

    $text .= "<P><I>$lang_ipfilters_Forward_manu_info</I>\n";

  }

  if ($n == "") { $n=0; };
  $text .= "<INPUT TYPE=HIDDEN NAME=\"n\" VALUE=\"$n\">\n";
  $text .= "\n<UL>\n<LI>$lang_Validation: <INPUT TYPE=submit VALUE=\" OK \"></UL></FORM><HR>\n";

  $text .= "<FORM METHOD=GET ACTION=ip_filters.php>\n";
  $text .= "<B>$lang_ipfilters_Firewall_assistant:</B><BR>\n";
  $text .= "<INPUT TYPE=hidden NAME=action VALUE=firewall_assistant>\n";
      $text .= "<SELECT NAME=prule>\n";
      $text .= "<OPTION VALUE=NONE $s1>$lang_ipfilters_Assist_select_rule\n";
      $text .= "<OPTION VALUE=ACCEPT $s1>$lang_ipfilters_Assist_accept\n";
      $text .= "<OPTION VALUE=DENY $s2>$lang_ipfilters_Assist_deny\n";
      $text .= "</SELECT>\n";
      $text .= "<SELECT NAME=pservice>\n";
      $text .= "<OPTION VALUE=NONE $s1>$lang_ipfilters_Assist_select_service\n";
      $text .= "<OPTION VALUE=FTP $s1>FTP (File Transfert Protocol)\n";
      $text .= "<OPTION VALUE=POP3 $s2>POP3 (Post Office Protocol)\n";
      $text .= "<OPTION VALUE=HTTP $s2>HTTP (Web)\n";
      $text .= "<OPTION VALUE=HADMIN $s2>HADMIN (SLIS interface)\n";
      $text .= "</SELECT>\n";
  $text .= "<INPUT TYPE=submit VALUE=$lang_Add>\n";
  $text .= "</FORM>\n";
  $text .= "<HR>\n";  

  $text .= "<DIV ALIGN=RIGHT><A HREF=ip_filters.php>&lt;&lt;</A>&nbsp;&nbsp;</DIV><BR>\n";

  // Print the form
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_ipfilters_Input_title,$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";        
}




###############################################################################################################################################
# Validation of the firewall form
if ($action=="firewall") {

  # Validity tests
  $ok=1;
  $text = "<BR><FONT FACE=HELVETICA,ARIAL>\n";
  if ($level != "all" && $level != "nothing" && $level != "level1" && $level != "level2" && $level != "level3") {$ok=0; $text .= "<FONT COLOR=FF0000>$level is not a valid rule set!</FONT><BR>\n";}  
  for ($i=1;$i<=$n;$i++) {
    $var="rule$i"; $rule=$$var;
    $var="protocol$i"; $protocol=$$var;
    $var="source$i"; $source=$$var;
    $var="source_mask$i"; $source_mask=$$var;
    $var="source_port$i"; $source_port=$$var;
    $var="dest$i"; $dest=$$var;
    $var="dest_mask$i"; $dest_mask=$$var;
    $var="dest_port$i"; $dest_port=$$var;
    if ($source_port == "") { $source_port=0; }
    if ($dest_port == "") { $dest_port=0; }
    if ($rule != "MASQ" && $rule != "DENY" && $rule != "ACCEPT") {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $rule is not a valid policy</FONT><BR>\n";}
    if (!isip($source)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error1 ($source)</FONT><BR>\n";}
    if (!isip($source_mask)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error2 ($source_mask)</FONT><BR>\n";}
    if (!(preg_match("/^\d*$/",$source_port)) || !($source_port>=0 && $source_port<=65535)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error3 ($source_port)</FONT><BR>\n";}
    if (!isip($dest)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error4 ($dest)</FONT><BR>\n";}
    if (!isip($dest_mask)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error5 ($dest_mask)</FONT><BR>\n";}
    if (!(preg_match("/^\d*$/",$dest_port)) || !($dest_port>=0 && $dest_port<=65535)) {$ok=0; $text .= "<FONT COLOR=FF0000>Rule $i: $lang_ipfilters_Error6 ($dest_port)</FONT><BR>\n";}
  }

  # Do the inserts only if tests have been passed
  if ($ok==1) {

    $error="";

    # Clear the old rules
    $db = dbconnect();
    $query="delete from security_filters where type='input'"; 
    $result=pg_exec($db,$query);

    # Insert the predefined rule
    $query="insert into security_filters (filter,type,rule,predefined,predefined_string) values ('1','input','ACCEPT','true','$level')"; 
    $result=pg_exec($db,$query);

    # Insert the manualy added rules
    for ($i=1;$i<=$n;$i++) {
      $filter=$i+1;
      $var="rule$i"; $rule=$$var;
      $var="protocol$i"; $protocol=$$var;
      $var="source$i"; $source=$$var;
      $var="source_mask$i"; $source_mask=$$var;
      $var="source_port$i"; $source_port=$$var;
      $var="dest$i"; $dest=$$var;
      $var="dest_mask$i"; $dest_mask=$$var;
      $var="dest_port$i"; $dest_port=$$var;
      if ($source_port == "") { $source_port=0; }
      if ($dest_port == "") { $dest_port=0; }
      $query="insert into security_filters (filter,type,rule,predefined,protocol,src,src_mask,src_port,dst,dst_mask,dst_port) values ('$filter','input','$rule','false','$protocol','$source','$source_mask','$source_port','$dest','$dest_mask','$dest_port')"; 
      $result=pg_exec($db,$query);
    }
    $text .= "<I>". $lang_ipfilters_OK ."</I><BR>\n";
    touch("$QUEUE/tbp");
  }
  else { $error="<FONT COLOR=FF0000>ERROR</FONT>"; }
  $text .= "<BR><DIV ALIGN=RIGHT><A HREF=ip_filters.php?action=firewall_form>&lt;&lt;</A>&nbsp;&nbsp;</DIV></FONT><BR>\n";
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,"Filters script $error",$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";  
}


###############################################################################################################################################
// Printing of the rules
if ($action=="print") {
  $text = "<BR><PRE>\n";
  $text .= `cat /usr/local/sbin/masquerade`;
  $text .= "</PRE><BR>\n";

  // Print
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,"Filters script",$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";        

}


###############################################################################################################################################
// FIREWALL ASSISTANT
if ($action=="firewall_assistant") {
  
  // select the last index of input rules
  $db = dbconnect();
  $query="select filter from security_filters where type='input' order by filter desc limit 1"; 
  $result=pg_exec($db,$query);
  $last=pg_result($result,0,"filter");
  $last++;

  // insert the rule with index+1
  switch ($pservice) {
    case "FTP" : 
      $query="insert into security_filters (filter,rule,predefined,type,protocol,src,src_mask,src_port,dst,dst_mask,dst_port) values ('$last','$prule','false','input','tcp','all','all','0','public','public','21')";   
      $result=pg_exec($db,$query);
      $last++;
      $query="insert into security_filters (filter,rule,predefined,type,protocol,src,src_mask,src_port,dst,dst_mask,dst_port) values ('$last','$prule','false','input','tcp','all','all','0','public','public','20')";   
      break;
    case "POP3" : 
      $query="insert into security_filters (filter,rule,predefined,type,protocol,src,src_mask,src_port,dst,dst_mask,dst_port) values ('$last','$prule','false','input','tcp','all','all','0','public','public','110')";   
      break;
    case "HTTP" : 
      $query="insert into security_filters (filter,rule,predefined,type,protocol,src,src_mask,src_port,dst,dst_mask,dst_port) values ('$last','$prule','false','input','tcp','all','all','0','public','public','80')";   
      break;
    case "HADMIN" : 
      $query="insert into security_filters (filter,rule,predefined,type,protocol,src,src_mask,src_port,dst,dst_mask,dst_port) values ('$last','$prule','false','input','tcp','all','all','0','public','public','1098')";   
      break;
  }
  $result=pg_exec($db,$query);
  

  // redirect to the form page
  header("Location: ip_filters.php?action=firewall_form");

}


###############################################################################################################################################
// INLINE HELP

if ($action=="forward_hlp1") {

  if ($LANGUAGE=="french") {
    $text = "

<B>Description des ensembles de r&ecirc;gles de routage</B>:
<DL>
<DT><B>TOUT PASSE</B>
<DD>Aucun filtrage, &agrave; part le web (HTTP) et la messagerie (SMTP) 
qui seront interdits sans passer par les passerelles (le proxy-cache et
la
passerelle SMTP qui tournent sur votre SLIS). <BR>
SLIS fera du masquerading pour tous les services qui peuvent fonctionner
avec ce principe.<P>
<DT><B>SECURITE NIVEAU 1</B>
<DD>Le routage avec masquerading est actif par d&eacute;faut, mais
certains services sont filtr&eacute;s. Ils seront interdits, donc
inutilisables &agrave; travers le SLIS. Les services qui sont
d&eacute;sactiv&eacute;s ici, sont r&eacute;put&eacute;s
vuln&eacute;rables et sont, en g&eacute;n&eacute;ral, inutiles pour
vos applications.<BR>
<I>Services interdits:</I> Relai de messagerie externe (SMTP) sauf
serveurs du domaine, Service de Noms (DNS) externe, Finger, SNMP, web
(HTTP) sans passage par le
proxy-cache, autre proxy-cache Squid.<P>
<DT><B>SECURITE NIVEAU 2</B>
<DD>Le routage est d&eacute;sactiv&eacute; par d&eacute;faut, mais
certains services sont rendus actifs par masquerading.<BR>
<I>Services autoris&eacute;s:</I>Chat (IRC), Bureau de poste (POP3, KPOP 
et IMAP), Console texte &agrave; distance (TELNET), Transfert de fichier
en mode <B>non passif</B> (FTP), Groupes de nouvelles (NEWS), Changement de mot de
passe POP (POPPASSD), SMTP uniquement sur le serveur du
domaine, Connexion aux annuaires LDAP, Utilisation de clients Lotus
Notes vers serveurs Domino,SSH.<P> 
<DT><B>SECURITE NIVEAU 3</B>
<DD>Idem que SECURITE NIVEAU 2, mais moins de services :<BR>
<I>Services autoris&eacute;s:</I>Transfert de fichier
en mode passif (FTP),Groupes de nouvelles (NEWS), SMTP uniquement sur
le serveur du domaine, Rel&egrave;ve de boites POP uniquement sur
le serveur du domaine.<P>
<DT><B>RIEN NE PASSE</B>
<DD>Aucun routage actif. Seuls le web et la messagerie seront utilisables 
et uniquement en passant par les passerelles (le proxy-cache et le relai
SMTP). 
</DL> 
<I>
Si vous ne savez pas quoi choisir, nous vous conseillons 2
m&eacute;thodes:<P>
- Si vous &ecirc;tes un peu paranoiaque (ce n'est pas
p&eacute;joratif dans ce domaine!) choisissez RIEN NE PASSE. Et si, un
jour, un service particulier d'Internet semble ne pas fonctionner, passez
 SECURITE NIVEAU 3, puis NIVEAU 2  si cela ne fonctionne toujours
pas, et ainsi de suite. <P>
- Sinon, choisissez simplement SECURITE NIVEAU 2. C'est le meilleur
rapport s&eacute;curit&eacute;/fonctionnalit&eacute;s.
    ";
  }

  else { 
    $text = "From file ip_filters.php: This help is not yet avalaible in your language.<P>";
  } 

  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,"Forward help",$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";        
}


if ($action=="firewall_hlp1") {

  if ($LANGUAGE=="french") {
    $text = "

<B>Description des ensembles de r&ecirc;gles de pare-feu</B>:
<DL>
<DT><B>PAS DE PARE-FEU</B>
<DD>Aucun filtrage. Votre SLIS autorisera toutes connexions externes &agrave; ses services. Ce niveau est fortement d&eacute;conseill&eacute;.
Il ne devrait servir qu'au diagnostic, au cas o&ugrave; un service ne semble pas fonctionner dans le niveau optimum.<P>
<DT><B>PARE-FEU OPTIMAL</B>
<DD>C'est le niveau de s&eacute;curit&eacute; par d&eacute;faut, qui comporte un certain nombre de 
r&egrave;gles que nous avons choisi pour vous, correspondant &agrave; un usage courant.
Nous vous conseillons fortement ce niveau.<BR>
<I>Plus pr&eacute;cis&eacute;ment, tous est interdit par defaut, sauf:</I> Connexion depuis le relai de messagerie de votre domaine (SMTP),
connexions depuis tout internet vers SSH,HTTP,POP3 et l'interface d'administration du SLIS.
<P>
<DT><B>PARE-FEU TOTAL</B>
<DD>
C'est un niveau que vous pouvez utiliser si vous ne voulez pas que des connexions externes se produisent
sur votre SLIS et votre r&eacute;seau local. Il sera cependant possible, aux services de votre domaine, de se connecter sur l'interface d'administration de votre SLIS, en cas de besoin de d&eacute;pannage.
<P>
<DT><B>REGLES SUPPLEMENTAIRES</B>
<DD>
Les r&egrave;gles suppl&eacute;mentaires sont r&eacute;serv&eacute;es aux experts qui peuvent ainsi
autoriser ou refuser l'acc&egrave;s &agrave; certains ports du SLIS en les d&eacute;finissant avec pr&eacute;cision. Lorsque des r&egrave;gles suppl&eacute;mentaires sont pr&eacute;sentes, elles sont ajout&eacute;es avant toutes les autres
du niveau choisi. Le niveau choisi pr&eacute;c&eacute;demment devient ainsi le mode par d&eacute;faut. 
</DL> 
<I>
Si vous ne savez pas quoi choisir, choisissez OPTIMAL
<BR>
    ";
  }

  else { 
    $text = "From file ip_filters.php: This help is not yet avalaible in your language.<P>";
  } 

  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,"Firewall help",$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";        
}

// The end
print endHTML();

?>
