<?php
/* $Id: schedule.php,v 1.6 2001/06/18 11:37:56 gyzmo Exp $

This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been writen by "votre nom"- copyright (C) 2001
Ce script  t crit par "votre nom" - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License
along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  <slis@ac-grenoble.fr>

*/

// tools and libs
require("../inc/pgsql.inc.php");
require("../inc/html.inc.php");
require("../inc/lib.inc.php");
require("../inc/subnet.inc.php");

// connection sql
$db = dbconnect();

//loading html part
$starthtml = startHTML("$lang_Subnet_administration");
$end = endHTML();

//html header output
print $starthtml;

// manage hours
if($submit)
{
        $start = ( $starthours * 60 ) + $startminutes;
        $end = ( $endhours * 60 ) + $endminutes;
        $day = $jour;
        $check = check_subnet_params($db,$start,$end,$subnetid,$day); // check if params are ok and return 1 or error msg
        if($check == 1)
        {
                $query = "insert into subnetstat (subid,actif,inactif,days) values ('$subnetid','$start','$end','$day');";
                $result = pg_exec($db,$query);
        }
        else
        {
                $contenu .= "<br><center>".errormsg($check)."</center><hr>\n";
        }

}

// remove hours field
if($mode == "remove")
{
        if($id)
        {
                $query = "delete from subnetstat where id='$id' ;";
                $result = pg_exec($db,$query);
        }
}

// build page
if($subnetid)  // check if params
{
        $subname = get_subnet_name($db,$subnetid);
        // bars
        $bar_lundi = draw_subnet_hours($db,"lundi",$subnetid);
        $bar_mardi = draw_subnet_hours($db,"mardi",$subnetid);
        $bar_mercredi = draw_subnet_hours($db,"mercredi",$subnetid);
        $bar_jeudi = draw_subnet_hours($db,"jeudi",$subnetid);
        $bar_vendredi = draw_subnet_hours($db,"vendredi",$subnetid);
        $bar_samedi = draw_subnet_hours($db,"samedi",$subnetid);
        $bar_dimanche = draw_subnet_hours($db,"dimanche",$subnetid);
        $hours = array(1, 2, 3, 4, 5, 6, 7, 8, 9,10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23);
        $minutes = array(5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55);
        $select_hours = form_select("starthours",$hours);
        $select_min = form_select("startminutes",$minutes);
        $select_fhours = form_select("endhours",$hours);
        $select_fmin = form_select("endminutes",$minutes);
        // table content
        $contenu .= "<table align=\"center\" width=\"100%\" border=\"0\">\n";
        $contenu .= "<tr><td align=\"center\" colspan=\"2\"><b>$lang_Legend</td>\n";
        $contenu .= "<tr><td align=\"center\" colspan=\"2\">$lang_Actif <img src=\"../images/ledgreen.gif\" ALIGN=\"absmiddle\" border=\"0\">       $lang_Inactif <img src=\"../images/ledred.gif\" ALIGN=\"absmiddle\" border=\"0\"></td>";
        $contenu .= "<tr><td align=\"center\" colspan=\"2\"><hr width=\"20\"></td>\n";
        $contenu .= "<tr><td><center>$lang_Monday :</center></td><td align=\"center\">".$bar_lundi."</td>";
        $contenu .= "<tr><td>&nbsp</td><td align=\"center\"><form action=\"schedule.php\" method=\"get\">$lang_Subnet_actif_of $select_hours H $select_min A $select_fhours H $select_fmin \n";
        // hidden params
        $contenu .= "<input type=\"hidden\" name=\"jour\" value=\"1\"><input type=\"hidden\" name=\"subnetid\" value=\"$subnetid\"><input type=\"submit\" name=\"submit\" value=\"ok\">\n";
        $contenu .= "</td></form>\n";
        $contenu .= "<tr><td align=\"center\" colspan=\"2\">&nbsp;</td>\n";
        $contenu .= "<tr><td><center>$lang_Thuesday :</center></td><td align=\"center\">".$bar_mardi."</td>";
        $contenu .= "<tr><td>&nbsp</td><td align=\"center\"><form action=\"schedule.php\" method=\"get\">$lang_Subnet_actif_of $select_hours H $select_min A $select_fhours H $select_fmin \n";
        // hidden params
        $contenu .= "<input type=\"hidden\" name=\"jour\" value=\"2\"><input type=\"hidden\" name=\"subnetid\" value=\"$subnetid\"><input type=\"submit\" name=\"submit\" value=\"ok\">\n";
        $contenu .= "</td></form>\n";
        $contenu .= "<tr><td align=\"center\" colspan=\"2\">&nbsp;</td>\n";
        $contenu .= "<tr><td><center>$lang_Wednesday :</center></td><td align=\"center\">".$bar_mercredi."</td>";
        $contenu .= "<tr><td>&nbsp</td><td align=\"center\"><form action=\"schedule.php\" method=\"get\">$lang_Subnet_actif_of $select_hours H $select_min A $select_fhours H $select_fmin \n";
        // hidden params
        $contenu .= "<input type=\"hidden\" name=\"jour\" value=\"3\"><input type=\"hidden\" name=\"subnetid\" value=\"$subnetid\"><input type=\"submit\" name=\"submit\" value=\"ok\">\n";
        $contenu .= "</td></form>\n";
        $contenu .= "<tr><td align=\"center\" colspan=\"2\">&nbsp;</td>\n";
        $contenu .= "<tr><td><center>$lang_Thursday :</center></td><td align=\"center\">".$bar_jeudi."</td>";
        $contenu .= "<tr><td>&nbsp</td><td align=\"center\"><form action=\"schedule.php\" method=\"get\">$lang_Subnet_actif_of $select_hours H $select_min A $select_fhours H $select_fmin \n";
        // hidden params
        $contenu .= "<input type=\"hidden\" name=\"jour\" value=\"4\"><input type=\"hidden\" name=\"subnetid\" value=\"$subnetid\"><input type=\"submit\" name=\"submit\" value=\"ok\">\n";
        $contenu .= "</td></form>\n";
        $contenu .= "<tr><td align=\"center\" colspan=\"2\">&nbsp;</td>\n";
        $contenu .= "<tr><td><center>$lang_Friday :</center></td><td align=\"center\">".$bar_vendredi."</td>";
        $contenu .= "<tr><td>&nbsp</td><td align=\"center\"><form action=\"schedule.php\" method=\"get\">$lang_Subnet_actif_of $select_hours H $select_min A $select_fhours H $select_fmin \n";
        // hidden params
        $contenu .= "<input type=\"hidden\" name=\"jour\" value=\"5\"><input type=\"hidden\" name=\"subnetid\" value=\"$subnetid\"><input type=\"submit\" name=\"submit\" value=\"ok\">\n";
        $contenu .= "</form></td>\n";
        $contenu .= "<tr><td align=\"center\" colspan=\"2\">&nbsp;</td>\n";
        $contenu .= "<tr><td><center>$lang_Saturday :</center></td><td align=\"center\">".$bar_samedi."</td>";
        $contenu .= "<tr><td>&nbsp</td><td align=\"center\"><form action=\"schedule.php\" method=\"get\">$lang_Subnet_actif_of $select_hours H $select_min A $select_fhours H $select_fmin \n";
        // hidden params
        $contenu .= "<input type=\"hidden\" name=\"jour\" value=\"6\"><input type=\"hidden\" name=\"subnetid\" value=\"$subnetid\"><input type=\"submit\" name=\"submit\" value=\"ok\">\n";
        $contenu .= "</form></td>\n";
        $contenu .= "<tr><td align=\"center\" colspan=\"2\">&nbsp;</td>\n";
        $contenu .= "<tr><td><center>$lang_Sunday :</center></td><td align=\"center\">".$bar_dimanche."</td>";
        $contenu .= "<tr><td>&nbsp</td><td align=\"center\"><form action=\"schedule.php\" method=\"get\">$lang_Subnet_actif_of $select_hours H $select_min A $select_fhours H $select_fmin \n";
        // hidden params
        $contenu .= "<input type=\"hidden\" name=\"jour\" value=\"7\"><input type=\"hidden\" name=\"subnetid\" value=\"$subnetid\"><input type=\"submit\" name=\"submit\" value=\"ok\">\n";
        $contenu .= "</form></td>\n";
        $contenu .= "<tr><td align=\"center\" colspan=\"2\"><a href=\"subnets.php\">$lang_Back</a></td>\n";
        $contenu .= "</table>\n";
}

// print table
$val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,"$lang_Subnet_Hours_for_subnet <b>$subname</b>",$titre_color);
$val = center($val);
$val = saut(2)."$val";
print "$val\n";
print saut(2);

// end of page
print $end;

//close sql
pg_close($db);
?>
